; Assembler Source File
; Created 9/12/00, 11:06:02 PM
;
; BOSA v 1.0.0
; basic output sound algorithm
;
; the cyborg operation
; www.igloowebdesign.com/tco
;
; input:
;	d0.w	=	frequency
;	d1.w	=	duration (miliseconds)
;
; output:
;	sound (freq) at (duration)

	xdef	_library
	xdef	bosalib@0000

        include "doorsos.h"
	xdef _ti89
	
bosalib@0000:
	movem.l		d0-d2,-(a7)
	move.l		d0,-(a7)		; Save d0 (freq)
	move.w		#$700,d0
	trap		#1			; Disable interrupts
	move.w		d0,oldsr		; Store old sr
	move.l		(a7)+,d0		; Restore d0
	bset.b		#6,$60000C		; Init full I/O control
	move.l		d0,d2			; Copy freq
sloop2:
	subq.l		#1,d0
	beq		dosnd2			; Check if we should set wires
	bra		nosnd2			; Obviuosly not
dosnd2:
	bchg.b		#0,$60000E		; Change wire state
	bchg.b		#1,$60000E		; Change wire state
	move.l		d2,d0			; Reload freq
nosnd2:
	dbra		d1,sloop2		; Beep for length
sdone2:
	bclr.b 		#0,$60000E		; Set wire low
	bclr.b 		#1,$60000E		; Set wire low
	move.b 		#$8D,$60000C
	move.w		oldsr,d0
	trap		#1
	movem.l		(a7)+,d0-d2
	rts

oldsr	dc.w	0
	end
